package cz.uhk.iot.gui.event;

import cz.uhk.iot.gui.modal.RadiusChangePassDialog;
import cz.uhk.iot.service.SecurityService;
import cz.uhk.iot.service.SerialCommunicationService;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ChangePasswordListener implements ActionListener {

    private SerialCommunicationService serialCommunicationService;
    private SecurityService securityService;
    private JPasswordField oldPassValue;
    private JPasswordField newPassValue;
    private ButtonGroup typeGroup;
    private RadiusChangePassDialog radiusChangePassDialog;

    public ChangePasswordListener(SerialCommunicationService serialCommunicationService, SecurityService securityService, JPasswordField oldPassValue, JPasswordField newPassValue, ButtonGroup typeGroup, RadiusChangePassDialog radiusChangePassDialog) {
        this.serialCommunicationService = serialCommunicationService;
        this.oldPassValue = oldPassValue;
        this.newPassValue = newPassValue;
        this.typeGroup = typeGroup;
        this.radiusChangePassDialog = radiusChangePassDialog;
        this.securityService = securityService;
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        String type = typeGroup.getSelection().getActionCommand();

        String oldPass = new String(oldPassValue.getPassword());
        String newPass = new String(newPassValue.getPassword());

        serialCommunicationService.writeData(type + "p" + oldPass + "_" + newPass);

        oldPassValue.setText("");
        newPassValue.setText("");

        String userName = type.equals("b") ? "BluetoothNode" : "ZigbeeNode";
        radiusChangePassDialog.setUserToLabel(userName);
        radiusChangePassDialog.setHash(securityService.generateRadiusPassFromClearText(newPass));
        radiusChangePassDialog.setVisible(true);
    }
}
