package cz.uhk.iot.gui.panel;

import cz.uhk.iot.gui.event.ChangePasswordListener;
import cz.uhk.iot.gui.modal.RadiusChangePassDialog;
import cz.uhk.iot.service.RadiusService;
import cz.uhk.iot.service.SecurityService;
import cz.uhk.iot.service.SerialCommunicationService;

import javax.swing.*;
import java.awt.*;

public class ChangePasswordPanel extends JPanel {

    private JLabel oldPassLabel;
    private JPasswordField oldPassValue;
    private JLabel newPassLabel;
    private JPasswordField newPassValue;
    private JButton submit;

    public ChangePasswordPanel(SerialCommunicationService serialCommunicationService, SecurityService securityService, ButtonGroup typeGroup) {
        GridBagLayout layout = new GridBagLayout();
        setLayout(layout);

        GridBagConstraints c = new GridBagConstraints();

        oldPassValue = new JPasswordField(15);
        oldPassLabel = new JLabel("Staré heslo: ");
        oldPassLabel.setLabelFor(oldPassValue);
        oldPassLabel.setHorizontalAlignment(SwingConstants.CENTER);
        c.weightx = 0.5;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.gridx = 0;
        c.gridy = 0;
        add(oldPassLabel, c);

        c.weightx = 0.5;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.gridx = 1;
        c.gridy = 0;
        add(oldPassValue, c);

        newPassValue = new JPasswordField(15);
        newPassLabel = new JLabel("Nové heslo: ");
        newPassLabel.setLabelFor(newPassValue);
        newPassLabel.setHorizontalAlignment(SwingConstants.CENTER);
        c.weightx = 0.5;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.gridx = 0;
        c.gridy = 1;
        add(newPassLabel, c);

        c.weightx = 0.5;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.gridx = 1;
        c.gridy = 1;
        add(newPassValue, c);

        RadiusChangePassDialog radiusChangePassDialog = new RadiusChangePassDialog();

        ChangePasswordListener changePasswordListener =
                new ChangePasswordListener(
                        serialCommunicationService,
                        securityService,
                        oldPassValue,
                        newPassValue,
                        typeGroup,
                        radiusChangePassDialog
                );

        submit = new JButton("Odeslat");
        submit.setSize(100, 20);
        submit.addActionListener(changePasswordListener);
        c.weightx = 1;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.gridx = 1;
        c.gridy = 2;
        add(submit, c);
    }
}
