package cz.uhk.iot.gui.panel;

import cz.uhk.iot.service.SecurityService;
import cz.uhk.iot.service.SerialCommunicationService;

import javax.swing.*;
import java.awt.*;

public class ControlPanel extends JPanel {

    private ShowDataPanel temperaturePanel;

    private NodeSwitchPanel nodeSwitchPanel;

    private LightSwitchPanel lightSwitchPanel;

    private ChangePasswordPanel changePasswordPanel;

    public ControlPanel(SerialCommunicationService serialCommunicationService, SecurityService securityService) {
        GridBagLayout layout = new GridBagLayout();
        setLayout(layout);

        setPreferredSize(new Dimension(250, 300));
        GridBagConstraints c = new GridBagConstraints();

        c.fill = GridBagConstraints.VERTICAL;
        c.weighty = 1;
        c.gridx = 0;
        c.gridy = 0;
        temperaturePanel = new ShowDataPanel();
        temperaturePanel.setAlignmentY(CENTER_ALIGNMENT);
        add(temperaturePanel, c);

        c.fill = GridBagConstraints.VERTICAL;
        c.weighty = 1;
        c.gridx = 0;
        c.gridy = 1;
        nodeSwitchPanel = new NodeSwitchPanel();
        add(nodeSwitchPanel, c);

        c.fill = GridBagConstraints.VERTICAL;
        c.weighty = 1;
        c.gridx = 0;
        c.gridy = 2;
        lightSwitchPanel = new LightSwitchPanel(serialCommunicationService, nodeSwitchPanel.getTypeGroup());
        add(lightSwitchPanel, c);

        c.fill = GridBagConstraints.VERTICAL;
        c.weighty = 1;
        c.gridx = 0;
        c.gridy = 3;
        changePasswordPanel = new ChangePasswordPanel(serialCommunicationService, securityService, nodeSwitchPanel.getTypeGroup());
        add(changePasswordPanel, c);

    }

    public ShowDataPanel getTemperaturePanel() {
        return temperaturePanel;
    }
}
