package cz.uhk.iot.gui.panel;

import cz.uhk.iot.service.SerialCommunicationService;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class SerialPortConnectPanel extends JPanel implements ActionListener {
    private JLabel portLabel;
    private JComboBox<String> portsBox;
    private JButton connectButton;
    private JButton disconnectButton;
    private JLabel portStatus;

    private SerialCommunicationService serialCommunicationService;

    public SerialPortConnectPanel(SerialCommunicationService serialCommunicationService) {
        FlowLayout flowLayout = new FlowLayout();
        setLayout(flowLayout);

        this.serialCommunicationService = serialCommunicationService;

        portLabel = new JLabel("Dostupné porty: ");
        add(portLabel);

        portsBox = new JComboBox<>();
        serialCommunicationService.getPortsNames().forEach(portName -> portsBox.addItem(portName));
        add(portsBox);

        connectButton = new JButton("Připojit");
        connectButton.setActionCommand("1");
        connectButton.addActionListener(this);
        add(connectButton);

        disconnectButton = new JButton("Odpojit");
        disconnectButton.setActionCommand("0");
        disconnectButton.addActionListener(this);
        add(disconnectButton);

        portStatus = new JLabel("Stav: Odpojeno");
        add(portStatus);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals("1")) {
            serialCommunicationService.connect((String) portsBox.getSelectedItem());
        } else {
            serialCommunicationService.disconnect();
        }
        if (serialCommunicationService.getConnected()) {
            portStatus.setText("Stav: Připojeno");
        } else {
            portStatus.setText("Stav: Odpojeno");
        }
    }
}
