package cz.uhk.iot.service;

public interface SecurityService {
    /**
     * Generate authorization token to be return to Arduino end node.
     *
     * @param nodeName
     * @param randomNum
     * @return
     */
    String generateAuthAcceptToken(String nodeName, String randomNum);

    /**
     * Generate password string stored in RADIUS for authentication from hashed password
     *
     * @param password
     * @return
     */
    String generateRadiusPassFromHash(String password);

    /**
     * Generate password string stored in RADIUS for authentication from clear password
     *
     * @param password
     * @return
     */
    String generateRadiusPassFromClearText(String password);
}
