package cz.uhk.iot.service;

import com.google.common.hash.Hashing;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.nio.charset.StandardCharsets;

@Service
public class SecurityServiceImpl implements SecurityService {

    @Value("${gw.seed:aaaa0000}")
    private String seed;

    public String generateAuthAcceptToken(String nodeName, String randomNum) {
        String composed = nodeName + randomNum;
        return hashMD5(composed);
    }

    public String generateRadiusPassFromHash(String password) {
        int sum = 0;
        for (int i = 0; i < password.length(); i++) {
            int num = password.charAt(i);
            sum += num;
        }
        String hexSum = Integer.toHexString(sum);
        StringBuilder sb = new StringBuilder();
        sb.append(hexSum).append(password).append(hexSum).append(seed);
        return hashSHA256(sb.toString());
    }

    public String generateRadiusPassFromClearText(String password) {
        return generateRadiusPassFromHash(hashMD5(hashSHA256(password)));
    }

    private String hashSHA256(String input) {
        return Hashing.sha256()
                .hashString(input, StandardCharsets.UTF_8)
                .toString();
    }

    private String hashMD5(String input) {
        return Hashing.md5()
                .hashString(input, StandardCharsets.UTF_8)
                .toString();
    }
}
