package cz.uhk.iot;

import com.google.common.hash.Hashing;
import cz.uhk.iot.service.SecurityService;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.nio.charset.StandardCharsets;


@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = TestConfig.class)
public class SecurityServiceTest {

    @Autowired
    private SecurityService securityService;

    @Test
    public void test() {
        String defaultPassHash = generateHash();

        String genPass = securityService.generateRadiusPassFromHash(defaultPassHash);
        Assert.assertEquals("839526ba17634100baf185a661a45b330af6498e1e46be65ced55d9e7bb3bb5f", genPass);
    }

    private String generateHash() {
        String sha256Hash = Hashing.sha256().hashString("passwordnode", StandardCharsets.UTF_8).toString();
        return Hashing.md5().hashString(sha256Hash, StandardCharsets.UTF_8).toString();
    }
}
