#define BT_RX 2
#define BT_TX 3
#define XBEE_RX 7
#define XBEE_TX 8
#define RED_LED_PIN 9
#define GREEN_LED_PIN 10

#include <SoftwareSerial.h>

SoftwareSerial bluetooth(BT_TX, BT_RX);
SoftwareSerial xbee(XBEE_TX, XBEE_RX);

char c = ' ';

void setup() {
  Serial.begin(9600);
  Serial.println("Koordinátor je připraven");
  bluetooth.begin(9600);
  xbee.begin(9600);
  pinMode(RED_LED_PIN, OUTPUT);
  pinMode(GREEN_LED_PIN, OUTPUT);
}

void loop() {
  bluetoothLoop();
  delay(500);
  readDataFromGW();
  xbeeLoop();
  delay(500);
  readDataFromGW();
}

void readDataFromGW() {
  if (Serial.available()) {
    c =  Serial.read();
    if ('b' == c) {
      while (Serial.available() == 0);
      String text = Serial.readString();
      bluetooth.listen();
      bluetooth.println(text);
      delay(1000);
      checkAndReadBluetoothData();
      
    } else if ('x' == c) {
      while (Serial.available() == 0);
      String text = Serial.readString();
      xbee.listen();
      xbee.println(text);
      delay(1000);
      checkAndReadXbeeData();
    }
  }
}

void checkAndReadBluetoothData() {
  while (bluetooth.available() > 0) {
    digitalWrite(RED_LED_PIN, HIGH);
    delay(10);
    digitalWrite(RED_LED_PIN, LOW);

    while (bluetooth.available() == 0);
    String response = bluetooth.readString();
    Serial.print("BT_");
    Serial.print(response);
  }
}

void checkAndReadXbeeData() {
  while (xbee.available() > 0) {
    digitalWrite(GREEN_LED_PIN, HIGH);
    delay(10);
    digitalWrite(GREEN_LED_PIN, LOW);

    while (xbee.available() == 0);
    String response = xbee.readString();
    Serial.print("XB_");
    Serial.print(response);
  }
}

void bluetoothLoop() {
  bluetooth.listen();
  bluetooth.print('?');
  delay(1000);
  checkAndReadBluetoothData();

}

void xbeeLoop() {
  xbee.listen();
  xbee.print('?');
  delay(1000);
  checkAndReadXbeeData();

}
